 Type TBull = Object
              {-----------------}
               S00 : TSPrite;
               Bul : Array[1..25] of Record
                      X,Y    : Real;
                      XVelo,
                      YVelo  : Real;
                      Soort  : Word;
                      Tracking : Boolean;
                      Active : Boolean;
                     End;
              {-----------------}
               Procedure Load;
               Procedure Shoot(StartX : LongInt; StartY, _XVelo, _YVelo, _Soort : Integer; _Tracking : Boolean);
               Procedure MoveAll;
               Procedure DrawAll;
              End;

 Var Bullets : TBull;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBull.Load;
 Var Index : Byte;
 Begin
  S00.Load('SPBULL.WAD',1);
  For Index := 1 To 25 Do With Bul[Index] Do Begin
   X := 0; Y := 0; Soort := 1;  Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBull.MoveAll;
 Function Tussen(A,B,C : Integer): Boolean;
 Begin
  IF (A < B) or (A > C) Then Tussen := True else tussen := False;
 End;
 Var Index : Byte;
 Begin
  For Index := 1 To 25 Do With Bul[Index] Do Begin
   If Tracking Then Begin
    If TrackX < X Then XVelo := XVelo - 0.04;
    If TrackX > X Then XVelo := XVelo + 0.04;
   End;
   X := X + XVelo;
   Y := Y + YVelo;
   If Tussen(Round(X),0,Screen_Width) Then Active := False;
   If Tussen(Round(Y),0,Screen_Height) Then Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)
 Procedure TBull.DrawAll;
 Var Index : Byte;
 Begin
  MoveAll;
  For Index := 1 To 25 Do With Bul[Index] Do
   If Active Then Begin
     S00.GotoXY(Round(X),Round(Y));
     S00.Current := Soort;
     S00.Draw;
   End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBull.Shoot;
 Var Index : Byte;
 Begin
  For Index := 1 To 25 Do With Bul[Index] Do Begin
   If Not Active Then Begin
    X := StartX; Y := StartY; XVelo := _XVelo; YVelo := _YVelo; Soort := _Soort;
    Tracking := _Tracking;
    Active := True;
    Break;
   End;
  End;
 End;
