 Type TExpl = Object
              {-----------------}
               S00 : TSPrite;
               Exp : Array[1..25] of Record
                      X,Y    : Integer;
                      Soort  : Word;
                      Active : Boolean;
                     End;
               Count : Byte;
              {-----------------}
               Procedure Load;
               Procedure Place(StartX,StartY, _Soort : Integer);
               Procedure DrawAll;
              End;

 Var Explosions : TExpl;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TExpl.Load;
 Var Index : Byte;
 Begin
  S00.Load('SPEXPL.WAD',1);
  For Index := 1 To 25 Do With Exp[Index] Do Begin
   X := 0; Y := 0; Soort := 1;  Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)


 Procedure TExpl.DrawAll;
 Var Index : Byte;
 Begin
    Inc(Count);
    If Count = 5 Then Count := 0;
  For Index := 1 To 25 Do With Exp[Index] Do
   If Active Then Begin
     S00.GotoXY(X,Y);
     S00.Current := Soort;
     If Soort = 8 Then Active := False;
     If Soort = 14 Then Active := False;
     S00.Draw;
     If Count = 4 Then
     Soort := Soort + 1;
   End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TExpl.Place;
 Var Index : Byte;
 Begin
  For Index := 1 To 25 Do With Exp[Index] Do Begin
   If Not Active Then Begin
    X := StartX; Y := StartY; Soort := _Soort;
    Active := True;
    Break;
   End;
  End;
 End;
