
 Type

 THighScore = Record
               Name  : String[30];
               Score : LongInt;
              End;

 THigh = Object
         {----------------}
          Spr00 : TSprite;
         {----------------}
          Data : Array[1..12] of THighScore;
          Swap : THighScore;
         {----------------}
          Procedure Load;
          Procedure View;
          Procedure SaveHigh;
         {----------------}
         End;

 Var HighScore : THigh;

 Procedure THigh.Load;
 Begin
  Spr00.LOAD('BACK.WAD', 1);
  Spr00.Current := 1;
 End;

 Var Hg : File;

 Procedure LoadHigh;
 Var Index : Byte;
 Begin
  {$I-}
  Assign(Hg, 'HIGHSCOR.E');
  Reset(Hg, 1);
  {$I+}
  If IoREsult <> 0 Then Exit;
  Seek(Hg, 0);
  {$I-}
  For Index := 1 To 12 Do BlockRead(Hg,Highscore.Data[Index],SizeOf(Highscore.Data[Index]));
  Close(hg);
 End;

 Procedure THigh.SaveHigh;
 Var Index : Byte;
 Begin
  {$I-}
  Assign(Hg, 'HIGHSCOR.E');
  Rewrite(Hg, 1);
  {$I+}
  If IoREsult <> 0 Then Exit;
  Seek(Hg, 0);
  For Index := 1 To 12 Do Begin
  If Live.NuScore > Data[Index].Score Then Begin
   Swap.Name := Naam;
   Swap.Score := Live.NuScore;
   BlockWrite(Hg,Highscore.Swap,SizeOf(Highscore.Swap));
   Live.NuScore := 0;
  End;
   BlockWrite(Hg,Highscore.Data[Index],SizeOf(Highscore.Data[Index]));
  End;
  Close(hg);
 End;

 Procedure THigh.View;
 Var X, Y : Word;
 Begin
  LoadHigh;
  SaveHigh;
  LoadHigh;
   For X := 0 To 20 Do begin
   For Y := 0 To 20 Do Begin
    Spr00.GotoXY(X*32,Y*32);
    Spr00.Draw;
   End;
  End;
  Blit_String(51,41-20,'HIGHSCORE', 0, True);
  Blit_String(50,40-20,'HIGHSCORE', 15, True);
  For Y := 1 To 12 Do With Data[Y] Do Begin
   Blit_String(51,(Y * 12)+41,Size(Name,25)+ZeroSize(Int2Str(Score),10), 0, True);
   Blit_String(50,(Y * 12)+40,Size(Name,25)+ZeroSize(Int2Str(Score),10), 15, True);
  End;
  Blit_String(51,220,'PRESS [ESC] TO EXIT', 0, True);
  Blit_String(50,220,'PRESS [ESC] TO EXIT', 15, True);
 End;