 Type TShip = Object
              {-----------------}
               S00 : TSprite;
               X,Y : Integer;
               LastOperate : LongInt;
               Count, Count2 : Byte;
               LeftTurret : Boolean;
               PowerUp : Byte;
              {-----------------}
               Procedure Load;
               Procedure Draw;
               Procedure Reset;
               Procedure LetUserOperate;
               Procedure DetectCollisions;
               Procedure Explode;
              {-----------------}
             End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Var MainShip : TShip;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)


 Procedure TShip.Load;
 Begin
  S00.Load('SPSHIP.WAD',1);
  Reset;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TShip.Reset;
 Begin
  X := (Screen_Width Shr 1) - 14;
  Y := 16+20;
  S00.Current := 1;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TShip.Draw;
 Begin
  If Live.Dead Then Exit;
  DetectCollisions;
  S00.GotoXY(X,Y);
  S00.Draw;
  If Keys[77] Then
  With Bullets Do Begin
    S00.GotoXY(X+4,Y-2);
    S00.Current := 1;
    IF Count < 7 Then S00.Current :=2;
    S00.Draw;
{    S00.GotoXY(X+15,Y-2);
    S00.Draw;}
  End;
  If Keys[75] Then
  With Bullets Do Begin
    S00.Current := 1;
    IF Count < 7 Then S00.Current :=2;
    S00.GotoXY(X+15,Y-2);
    S00.Draw;
  End;
  If Keys[80] Then
  With Bullets Do Begin
    S00.GotoXY(X+4,Y-2);
    S00.Current := 1;
    IF Count < 7 Then S00.Current :=2;
    S00.Draw;
    S00.GotoXY(X+15,Y-2);
    S00.Draw;
  End;
  If Keys[72] Then
  With Bullets Do Begin
    S00.GotoXY(X+4,Y+7);
    S00.Current := 3;
    IF Count < 7 Then S00.Current :=4;
    S00.Draw;
    S00.GotoXY(X+15,Y+7);
    S00.Draw;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TShip.LetUserOperate;
 Begin
   If Keys[75] then Begin
    IF X > 10 THen dec(X,Live.Speed);
   End;
   If Keys[77] then Begin
    IF X < 322 THen inc(X,Live.Speed);
   End;
   If Keys[72] then Begin
    IF Y > 10 THen dec(Y,Live.Speed);
   End;
   If Keys[80] then Begin
    IF Y < 200 THen inc(Y,Live.Speed);
   End;
   If Keys[57] Then Begin
    If Count2 = 1 Then Begin
    If LeftTurret Then S00.Current := 3 Else S00.Current := 2;
    LeftTurret := Not LeftTurret;
    Bullets.Shoot(X+6+((S00.Current-2)*8),Y+18,0,4,5,False);
   { MakeNote(50,0,0,Hihat);}

    If LeftTurret Then
    Case PowerUp of
      1 : Begin
           Bullets.Shoot(X  ,Y+18,-1,3,8,FAlse);
           Bullets.Shoot(X+20,Y+18,1,3,8,False);
          End;
      2 : Begin
           Bullets.Shoot(X-5,Y+18,-3,3,8,False);
           Bullets.Shoot(X  ,Y+18,-1,3,8,False);
           Bullets.Shoot(X+20,Y+18,1,3,8,False);
           Bullets.Shoot(X+25,Y+18,3,3,8,False);
          End;
    3:  Begin
           Bullets.Shoot(X-5,Y+18,-3,3,8,False);
           Bullets.Shoot(X-10,Y+18,-2,3,8,False);
           Bullets.Shoot(X  ,Y+18,-1,3,8,False);
           Bullets.Shoot(X+20,Y+18,1,3,8,False);
           Bullets.Shoot(X+25,Y+18,2,3,8,False);
           Bullets.Shoot(X+30,Y+18,3,3,8,False);
        End;
    4:  Begin
           Bullets.Shoot(X-16,Y+18,0 ,3,8,False);
           Bullets.Shoot(X  ,Y+18,-1,3,8,False);
           Bullets.Shoot(X+20,Y+18,1,3,8,False);
           Bullets.Shoot(X+35,Y+18,0,3,8,False);
        End;
    End;
    End;
    If (Count2 AND 14) = 14 Then
    Case PowerUp of
    4:  Begin
           Bullets.Shoot(X-10,Y+18,0,3,10,False);
           Bullets.Shoot(X+25,Y+18,0,3,11,False);
        End;
    End;
   End Else Begin
    S00.Current := 1;
    Count2 := 0;
   End;
    Inc(Count2);
    If Count2 > 5 Then S00.Current := 1;
    If Count2 = 15 Then Count2 := 0;
    Inc(Count);
{    If Count > 5 Then S00.Current := 1;}
    If Count = 15 Then Count := 0;
    TrackX := X;
    TrackY := Y;
   End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TShip.Explode;
 Var Index3 : Byte;
 Begin
        Live.Over := 0;
        Bullets.Shoot(Round(X)+12,Round(Y)+12,-1,-1,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12, 1,-1,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12,-1, 1,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12, 1, 1,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12,-2, 0,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12, 2, 0,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12, 0,-2,17,FAlse);
        Bullets.Shoot(Round(X)+12,Round(Y)+12, 0, 2,17,FAlse);
        For Index3 := 1 To 4 Do
        Explosions.Place(Round(X+Random(16)),Round(Y+Random(16)),9);
 End;

 Procedure TShip.DetectCollisions;
 Var Index : Byte;
     Index2 : Byte;
     Index3 : Byte;
     _X,_Y : Integer;
 Function Raakt(X1,Y1,X2,Y2 : Integer): Boolean;
 Begin
  IF (X2 > X1) and (X2 < X1+28) And
     (Y2 > Y1) and (Y2 < Y1+20) Then Raakt := True Else Raakt := False;
 End;
 Function Raakt2(X1,Y1,X2,Y2 : Integer): Boolean;
 Begin
  IF (X2 > X1) and (X2 < X1+28) And
     (Y2 > Y1) and (Y2 < Y1+28) Then Raakt2 := True Else Raakt2 := False;
 End;
 Begin
  If Live.Dead Then Exit;
    For Index2 := 1 To 5 Do If Bonus.Bul[Index2].Active Then
    If Raakt(X,Y,Bonus.Bul[Index2].X, Bonus.Bul[Index2].Y) Then Begin
     With Bonus.Bul[Index2] Do Begin
      Active := False;
      Case Count2 Of
      0..5 : If MainShip.PowerUp < MaxBonus Then Inc(MainShip.PowerUp) Else Begin
       Live.Scores(5000,X,Y);
      End;
      6..9 : Live.UnHit;
      10..16: Live.SpeedUp;
      End;
{      Live.Hit;}
      Explosions.Place(Round(X)+3,Round(Y)-2,1);
      Explosions.Place(Round(X),Round(Y)+1,1);
      Explosions.Place(Round(X)+5,Round(Y)+3,1);
     End;
    End;
    For Index2 := 1 To 25 Do If Bullets.Bul[Index2].Active Then
    If Raakt(X,Y,Round(Bullets.Bul[Index2].X), Round(Bullets.Bul[Index2].Y)) Then Begin
     With Bullets.Bul[Index2] Do Begin
      Active := False;
      If MainShip.PowerUp > 0 Then Dec(MainShip.PowerUp);
      Live.Hit;
      Live.SpeedDown;
      Explosions.Place(Round(X),Round(Y),9);
     End;
    End;
    For Index2 := 1 To 50 Do If Aliens.Exp[Index2].Active Then
    If Raakt2(Round(Aliens.Exp[Index2].X), Round(Aliens.Exp[Index2].Y),X+15,Y) Then Begin
     With Aliens.Exp[Index2] Do Begin
      Active := False;
      If MainShip.PowerUp > 0 Then Dec(MainShip.PowerUp);
      Live.Hit; Live.Hit;
      Live.SpeedDown;
      If Live.Dead Then Begin
        Explode;
      End;
{      Explosions.Place(Round(X),Round(Y),9);}
      For Index3 := 1 To 6 Do
      Explosions.Place(Round(X+Random(16)),Round(Y+Random(16)),9);
     End;
    End;
   End;
